cmake_policy(PUSH)

cmake_minimum_required(VERSION 2.6)


#конфигурируем NSIS-файл
configure_file(${LPCIE_SDK_SOURCE_DIR}/win_installer/lpcie_install.nsi.in
               ${LPCIE_SDK_BINARY_DIR}/lpcie_install.nsi @ONLY)

set(LPCIE_SDK_CONV_DIR ${CMAKE_CURRENT_BINARY_DIR}/sdk-conv)
file(MAKE_DIRECTORY ${LPCIE_SDK_CONV_DIR})


#set(VS64_SETENV "${VS2008_DIR}/vcvarsall.bat")
file(MAKE_DIRECTORY ${LPCIE_SDK_BINARY_DIR}/x64)

configure_file(${LPCIE_SDK_SOURCE_DIR}/win_installer/make64.bat.in
               ${LPCIE_SDK_BINARY_DIR}/x64/make.bat @ONLY)

configure_file(${LPCIE_SDK_SOURCE_DIR}/win_installer/make32.bat.in
               ${LPCIE_SDK_BINARY_DIR}/x86/make.bat @ONLY)
#x64 версию собираем с помощью WinSDK, так как Express студия поддерживает только x86
add_custom_target(api64
    COMMAND cmd /c make.bat
    WORKING_DIRECTORY ${LPCIE_SDK_BINARY_DIR}/x64
    DEPENDS sdk-conv
)

#x86 версию собираем 2008 студией (Express) для совместимости с Win2000
#set(VS2008_SETENV "${VS2008_DIR}/vcvarsall.bat")
file(MAKE_DIRECTORY ${LPCIE_SDK_BINARY_DIR}/x86)
add_custom_target(api32
    COMMAND cmd /c make.bat
    WORKING_DIRECTORY ${LPCIE_SDK_BINARY_DIR}/x86
    DEPENDS sdk-conv
    )

#создаем lib-файл для Borland C++ (лучше использовать последнюю версию,
#так как lib созданный с помощью Borland Builder 6 может не подойти к Embarcadero)
add_custom_target(borland_lib
    COMMAND "${IMPLIB}" -f borland.lib l502api.dll
    WORKING_DIRECTORY ${LPCIE_SDK_BINARY_DIR}/x86/api/l502api
    DEPENDS api32)

add_custom_target(mingw_lib32
    COMMAND "${GENDEF}" - -a  l502api.dll > l502api_mgw.def
    COMMAND "${DLLTOOL32}" -m i386 -l libl502api.a -k -d l502api_mgw.def
    WORKING_DIRECTORY ${LPCIE_SDK_BINARY_DIR}/x86/api/l502api
    DEPENDS api32)

add_custom_target(mingw_lib64
    COMMAND "${GENDEF}" - -a  l502api.dll > l502api_mgw.def
    COMMAND "${DLLTOOL64}" -m i386:x86-64 -l libl502api.a -k -d l502api_mgw.def
    WORKING_DIRECTORY ${LPCIE_SDK_BINARY_DIR}/x64/api/l502api
    DEPENDS api64)



string(REGEX REPLACE "/" "\\\\" CONVERT_SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR})
string(REGEX REPLACE "/" "\\\\" CONVERT_DEST_DIR ${LPCIE_SDK_CONV_DIR})

configure_file(${LPCIE_SDK_SOURCE_DIR}/win_installer/conv_cp1251.bat.in
               ${LPCIE_SDK_BINARY_DIR}/conv_sdk_cp1251.bat @ONLY)


#add_custom_target(firmware-conv
#    COMMAND cmd /c conv_firm_cp1251.bat
#    WORKING_DIRECTORY ${LPCIE_SDK_BINARY_DIR}
#    )
add_custom_target(sdk-conv
    COMMAND cmd /c conv_sdk_cp1251.bat
    WORKING_DIRECTORY ${LPCIE_SDK_BINARY_DIR}
    )

#собираем сам установщик
add_custom_target(win-installer
    #переводим устанавливаемые заголовки в виндовую кодировку из UTF-8
    #COMMAND ${ICONV} -f UTF-8 -t CP1251 ${LPCIE_SDK_SOURCE_DIR}/api/l502api/src/l502api.h > l502api.h
    #COMMAND ${ICONV} -f UTF-8 -t CP1251 ${LPCIE_SDK_SOURCE_DIR}/api/l502api/src/lpcie.h > lpcie.h
    #COMMAND ${ICONV} -f UTF-8 -t CP1251 ${LPCIE_SDK_SOURCE_DIR}/examples/msvc/l502_stream_read/main.c > l502_stream_read.c
    #COMMAND ${ICONV} -f UTF-8 -t CP1251 ${LPCIE_SDK_SOURCE_DIR}/examples/msvc/l502_cycle_out/main.c > l502_cycle_out.c
    #COMMAND ${ICONV} -f UTF-8 -t CP1251 ${LPCIE_SDK_SOURCE_DIR}/tools/lpcie-firm-update/readme.txt > lpcie-firm-update_readme.txt
    #по nsi файлу создаем установщик
    COMMAND ${NSIS_EXEC} ${LPCIE_SDK_BINARY_DIR}/lpcie_install.nsi
    #подписываем установщик
    COMMAND "${SIGNTOOL}" sign /v /ac "${LCARD_CERT}" /s PrivateCertStore /n "Joint Stock Company L Card" /t ${CERT_TIMESTAMP_URL} lpcie_setup.exe
    DEPENDS sdk-conv
    DEPENDS driver
    DEPENDS api64
    DEPENDS api32
    DEPENDS lpcieNet
    DEPENDS borland_lib
    DEPENDS mingw_lib32
    DEPENDS mingw_lib64
    DEPENDS l502api_pdf
    DEPENDS l502_low_level_pdf
    #DEPENDS firmware-conv
    WORKING_DIRECTORY ${LPCIE_SDK_BINARY_DIR}
    )

cmake_policy(POP)
